#include <stdio.h>
#include <string.h>
#include "draw.h"

#define WAV_FILE_LEN 1024
#define BMP_DATA_LEN 320*240*2
#define BI_RGB 0

/* please fix it, the bfSize should be u32, but I can't align the 1st 16bit to the next 32 */
typedef struct _bmp_header {
	//u16 bfType;
	u32 bfSize;
	u16 bfReserved1;
	u16 bfReserved2;
	u32 bfOffBits;
} bmp_header;

typedef struct _bmp_info_header {
	u32 biSize;
	u32 biWidth;
	u32 biHeight;
	u16 biPlanes;
	u16 biBitCount;
	u32 biCompression;
	u32 biSizeImage;
	u32 biXPelsPerMeter;
	u32 biYPelsPerMeter;
	u32 biClrUsed;
	u32 biClrImportant;
} bmp_info_header;

int main(int argc, char **argv) {

	FILE *wavefile, *bmpfile;
	u8 InputBuf[WAV_FILE_LEN];
	u8 OutputBuf[BMP_DATA_LEN];

	u16 bfType;
	bmp_header header;
	bmp_info_header info;

	char *bmpfilename;
	
	bzero(InputBuf, WAV_FILE_LEN);
	bzero(OutputBuf, BMP_DATA_LEN);

	if (argc > 2) {
		wavefile = fopen(argv[1], "r");
		fread(InputBuf, WAV_FILE_LEN, 1, wavefile);
		fclose(wavefile);
		bmpfilename = argv[2];
	} else { 
		fprintf(stderr, "Usage: %s <FILExxx.DAT> <filename.bmp>\nWill convert DSO Nano dumps to bmp\n", argv[0]);
		return(1);
	}

	Draw_RAW(InputBuf,OutputBuf);

	bfType = 0x4d42;
	//header.bfType = 0x4d42;
	header.bfSize = BMP_DATA_LEN+14+40;
	header.bfReserved1 = 0;
	header.bfReserved2 = 0;
	header.bfOffBits = 54;
	
	info.biSize = 40;
	info.biWidth = 320;
	info.biHeight = 240;
	info.biPlanes = 1;
	info.biBitCount = 16;
	info.biCompression = BI_RGB;
	info.biSizeImage = BMP_DATA_LEN;
	info.biXPelsPerMeter = 0;
	info.biYPelsPerMeter = 0;
	info.biClrUsed = 0;
	info.biClrImportant = 0;
	
	bmpfile = fopen(bmpfilename, "wb");
	fwrite(&bfType, 1, 2, bmpfile);
	fwrite(&header, 1, 12,  bmpfile);
	fwrite(&info, 1, 40, bmpfile);
	fwrite(OutputBuf, 1, BMP_DATA_LEN, bmpfile);
	fclose(bmpfile);

	return(0);
}
